﻿Type=Activity
Version=2.51
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region


'==============================
'       TO DO
'==============================
' Clean up Category List routines
' Add Edit routines

'==============================

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim ModMode As String
	Dim RecipeID As Int
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim sql1 As SQL
	Dim Cursor1 As Cursor
	'------------------------------
	' View Definitions
	'------------------------------			
	Dim btnAddIngredient As Button
	Dim btnAddRecipe As Button
	Dim btnCancel As Button
	Dim btnDone As Button
	Dim edtIngredients As EditText
	Dim edtInstructions As EditText
	Dim edtQty As EditText
	Dim edtServings As EditText
	Dim edtSource As EditText
	Dim edtTitle As EditText
	'Dim edtCategories As EditText	
	Dim lblUnits As Label
	Dim lvCategories As ListView	
	Dim lvIngredientList As ListView
	Dim lblCategories As Label
	'------------------------------
	' Other Globals for this code module
	'------------------------------		
	Dim IME1 As IME
	Dim UOMList As List
	Dim IngredientList As List
	Dim OptionList As List
	Dim CategoryList As List
	Dim RecipeCategoryList As List
	Dim RecipeCategoriesMap As Map
	Dim CategoryCount As Int
	Dim EditMode As Boolean
	Dim RecipeChanged As Boolean
	Dim InstructionsChanged As Boolean
	Dim IngredientsChanged As Boolean
	Dim CategoriesChanged As Boolean
	Dim btnHideKeyboard As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'------------------------------
	' Load the Activity for this code module
	'------------------------------	
	Activity.LoadLayout("NewRecipe10")
	sql1.Initialize(Main.DBFileDir,Main.DBFileName,True)
	Setup
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub ClearActivity
	edtIngredients.Text = ""
	edtInstructions.Text = ""
	edtQty.Text = ""
	edtServings.Text = ""
	edtSource.Text = ""
	edtTitle.Text = ""
	'edtCategories.Text = ""
	lvCategories.Clear
	lvIngredientList.Clear
End Sub

Sub Setup
	EditMode = False
	IME1.Initialize("")
	UOMList.Initialize
	OptionList.Initialize
	OptionList.AddAll(Array As String("Edit Ingredient","Cancel"))
	IngredientList.Initialize
	CategoryList.Initialize
	RecipeCategoryList.Initialize
	ClearActivity	
	SetCategoryListView
	LoadCategoryList
	FillCategoryListView
	LoadUOMList
	If ModMode = "Edit" Then
		EditMode = True
		'load recipe information
		Activity.Title = "Edit Recipe - " & RecipeID
		'load the recipe into the activity
		btnAddRecipe.Text = "Update Recipe"
		LoadRecipe(RecipeID)
	Else
		Activity.Title = "Enter New Recipe"
		btnAddRecipe.Text = "Add Recipe"
		ClearAll
	End If
End Sub

Sub LoadRecipe(pkid As Int)
	Dim rows As Int
	Dim cntr As Int
	Dim QueryString As String
	Dim Cursor1 As Cursor
	Dim m As Map
	Dim qty As String
	Dim uom As String
	Dim data As String
	Dim DisplayString As String
	Dim m As Map
	'-------------------------	
	'Load Recipe Information
	QueryString = "SELECT RecipeText,RecipeSource,RecipeServes FROM recipes WHERE idRecipes = " & pkid
	Cursor1 = sql1.ExecQuery(QueryString)
	rows = Cursor1.RowCount
	If rows > 0 Then
		Cursor1.Position = 0
		edtTitle.Text = Cursor1.GetString("RecipeText")
		edtSource.Text = Cursor1.GetString("RecipeSource")
		edtServings.Text = Cursor1.GetString("RecipeServes")
	End If
	'Load Instructions
	QueryString = "SELECT RecipeID,InstructionsData FROM instructions WHERE RecipeID = " & pkid
	Cursor1 = sql1.ExecQuery(QueryString)
	rows = Cursor1.RowCount
	If rows > 0 Then
		Cursor1.Position = 0
		edtInstructions.Text = Cursor1.GetString("InstructionsData")
	End If
	'Load Ingredients
	QueryString = "SELECT IngredientQty,IngredientUnit,IngredientData FROM ingredients WHERE RecipeID = " & pkid
	Cursor1 = sql1.ExecQuery(QueryString)
	rows = Cursor1.RowCount
	If rows > 0 Then
		For cntr = 0 To rows-1
			Cursor1.Position = cntr
			m.Initialize
			qty = Cursor1.GetString("IngredientQty")
			uom = Cursor1.GetString("IngredientUnit")
			data = Cursor1.GetString("IngredientData")
			DisplayString = qty & " " & uom & " " & data
			m.Put("Qty",qty)
			m.Put("UOM",uom)
			m.Put("Ingredient",data)
			IngredientList.Add(m)
			lvIngredientList.AddSingleLine(DisplayString)
			'Log(DisplayString)
		Next
	End If
	'Load Categories.
	QueryString = "SELECT categoriesmain.CatText as CatText, " & _
		         "recipes.idRecipes, categoriesmain.idCategoriesMain as CatKey FROM recipes " & _
				 "INNER JOIN recipecategories " & _
				 "ON (recipes.idRecipes = recipecategories.RecipeId) " & _
				 "INNER JOIN categoriesmain " & _
				 "ON (recipecategories.MainCatKey = categoriesmain.idCategoriesMain) " & _
				 "WHERE (recipes.idRecipes= " & pkid & ")"
	Cursor1 = sql1.ExecQuery(QueryString)
	rows = Cursor1.RowCount
	CategoryCount = rows
	RecipeCategoryList.Clear
	If rows > 0 Then
		For cntr = 0 To rows - 1
			Cursor1.Position = cntr
			m.Initialize
			m.Put("pkID",Cursor1.GetInt("CatKey"))
			m.Put("text",Cursor1.GetString("CatText"))
			RecipeCategoryList.Add(m)
			If cntr = 0 Then
				lblCategories.Text = m.Get("text")
			Else
				lblCategories.Text = lblCategories.Text & ", " & m.Get("text")
			End If
		Next
	End If	
	RecipeChanged = False
	InstructionsChanged = False
	IngredientsChanged = False
	CategoriesChanged = False
	Cursor1.Close
End Sub

Sub SetCategoryListView
	Dim label1 As Label
	'-------------------------	
	lvCategories.SingleLineLayout.ItemHeight = 35dip
	label1 = lvCategories.SingleLineLayout.Label
	label1.TextSize = 14
End Sub

Sub ClearAll
	edtIngredients.Text = ""
	edtInstructions.Text = ""
	edtQty.Text = ""
	edtServings.Text = ""
	edtSource.Text = ""
	edtTitle.Text = ""
	lblUnits.Text = ""
	lvIngredientList.Clear
End Sub

Sub LogUOMList
	Dim rows As Int
	Dim cntr As Int
	'-------------------------
	rows = Main.UOMCursor.RowCount 
	For cntr = 0 To rows-1
		Main.UOMCursor.Position = cntr
		'Log("ID - " & Main.UOMCursor.GetInt2(0) & " Text - " & Main.UOMCursor.GetString2(1))
	Next
End Sub

Sub LoadUOMList
	Dim rows As Int
	Dim cntr As Int
	Dim QueryString As String
	Dim Cursor1 As Cursor
	'-------------------------
	QueryString = "SELECT UOMText as Text FROM UOM ORDER BY Text asc"
	Cursor1 = sql1.ExecQuery(QueryString)
	rows = Cursor1.RowCount
	If rows > 0 Then
		For cntr = 0 To rows-1	
			Cursor1.Position = cntr
			UOMList.Add(Cursor1.GetString("Text"))
		Next
	End If
	Cursor1.Close
End Sub

Sub LoadCategoryList
	Dim rows As Int
	Dim cntr As Int
	Dim QueryString As String
	Dim Cursor1 As Cursor
	Dim m As Map
	'-------------------------
	QueryString = "SELECT * FROM categoriesmain ORDER BY CatText ASC"
	Cursor1 = sql1.ExecQuery(QueryString)
	rows = Cursor1.RowCount
	If rows > 0 Then
		For cntr = 0 To rows-1
			m.Initialize
			Cursor1.position = cntr
			m.Put("pkID",Cursor1.GetInt("idCategoriesMain"))
			m.Put("text",Cursor1.Getstring("CatText"))
			CategoryList.Add(m)
		Next
	End If
	Cursor1.Close
End Sub

Sub FillCategoryListView
	Dim cntr As Int
	Dim m As Map
	'-------------------------	
	For cntr = 0 To CategoryList.Size-1
		m.Initialize
		m = CategoryList.Get(cntr)
		lvCategories.AddSingleLine(m.Get("text"))
	Next
End Sub
Sub edtQty_EnterPressed
	IME1.HideKeyboard
End Sub

Sub edtIngredients_EnterPressed
	IME1.HideKeyboard
End Sub

Sub btnAddIngredient_Click
	Dim Item As String
	Dim m As Map
	Dim Units As String
	Dim resp As Int
	'-------------------------
	m.Initialize
	If edtQty.Text = "" Then
		resp = Msgbox2("Are you sure you want to continue?","No Quantity Entered","Yes","","NO",Null)
		If resp = DialogResponse.NEGATIVE Then
			Return
		End If
	End If
	If edtIngredients.Text <> "" Then
		m.Put("Qty",edtQty.Text)
		If lblUnits.Text <> "Click Here for Units" Then
			m.Put("UOM",lblUnits.Text)
			Units = lblUnits.Text
		Else
			m.Put("UOM","")
			Units = ""
		End If
		m.Put("Ingredient",edtIngredients.Text)
		Item = edtQty.Text & " " & Units & " " & edtIngredients.Text
		lvIngredientList.AddSingleLine(Item)
		IngredientList.Add(m)
		ClearIngredientArea
	End If
	IngredientsChanged = True
End Sub

Sub ClearIngredientArea
	edtQty.Text = ""
	lblUnits.Text = "Click Here for Units"
	edtIngredients.Text = ""
End Sub

Sub btnDone_Click
	Activity.Finish
End Sub


Sub btnAddRecipe_Click
	Dim LastpkID As Int
	Dim QueryString As String
	Dim cntr As Int
	Dim qty As String
	Dim uom As String
	Dim ingred As String
	Dim m As Map
	Dim isok As Boolean
	'-------------------------
	If Main.DebugMode = True Then
		Log("About to update recipe")
		Log("-----------------------")
		Log("RecipeChanged = " & RecipeChanged)
		Log("Instructionschanged = " & InstructionsChanged)
		Log("Ingredientschanged = " & IngredientsChanged)
		Log("Categorieschanged = " & CategoriesChanged)
	End If
	If btnAddRecipe.Text = "Update Recipe" Then	
		'update recipes
		If RecipeChanged = True Then
			QueryString = "UPDATE recipes SET " 
			QueryString = QueryString & "RecipeText = '" & CheckSingleQuote(edtTitle.Text)
			QueryString = QueryString & "', RecipeSource = '" & CheckSingleQuote(edtSource.Text)
			QueryString = QueryString & "', RecipeServes = '" & CheckSingleQuote(edtServings.Text)
			QueryString = QueryString & "' WHERE idRecipes = " & RecipeID
			Log(QueryString)
			sql1.ExecNonQuery(QueryString)
		End If
		'update instructions
		If InstructionsChanged = True Then
			QueryString = "UPDATE instructions SET "
			QueryString = QueryString & "InstructionsData = '" & CheckSingleQuote(edtInstructions.Text)
			QueryString = QueryString & "' WHERE RecipeID = " & RecipeID
			Log(QueryString)
			sql1.ExecNonQuery(QueryString)
		End If
		'update ingredients
		If IngredientsChanged = True Then
			'delete and re-add ingredients
			QueryString = "DELETE FROM ingredients WHERE RecipeID = " & RecipeID
			sql1.ExecNonQuery(QueryString)
			QueryString = "INSERT INTO ingredients (RecipeID,IngredientQty,IngredientUnit,IngredientData) VALUES (?,?,?,?)"
			Log(IngredientList.Size-1)
			LogIngredientlist
			For cntr = 0 To IngredientList.Size-1
				m.Initialize
				m = IngredientList.Get(cntr)
				sql1.ExecNonQuery2(QueryString,Array As String(RecipeID,m.Get("Qty"),m.Get("UOM"),m.Get("Ingredient")))
			Next		
		End If
		'update categories
		If CategoriesChanged = True Then
			If CategoryCount > 0 Then
				'delete and re-add categories
				QueryString = "DELETE FROM recipecategories WHERE RecipeID = " & RecipeID
				sql1.ExecNonQuery(QueryString)
			End If
			QueryString = "INSERT INTO recipecategories (RecipeID,MainCatKey) VALUES (?,?)"
			For cntr = 0 To RecipeCategoryList.Size-1
				m.Initialize
				m = RecipeCategoryList.Get(cntr)
				sql1.ExecNonQuery2(QueryString,Array As String(RecipeID,m.Get("pkID")))
			Next			
		End If
		RecipeChanged = False
		IngredientsChanged = False
		CategoriesChanged = False
		InstructionsChanged = False
		Msgbox("Recipe Updated","")
	Else
		LogIngredientlist
		If CheckRecipeData = False Then
			Return
		End If
		If CheckIngredientData = False Then
			Return
		End If
		If CheckInstructionData = False Then
			Return
		End If
		'write to recipes table
		QueryString = "INSERT INTO recipes (RecipeText,RecipeSource,RecipeServes) VALUES (?,?,?)"
		sql1.ExecNonQuery2(QueryString,Array As String(CheckSingleQuote(edtTitle.Text),CheckSingleQuote(edtSource.Text),CheckSingleQuote(edtServings.Text)))
		'-------------------------
		'write to ingredients table
		LastpkID = GetLastKey("recipes")
		QueryString = "INSERT INTO ingredients (RecipeID,IngredientQty,IngredientUnit,IngredientData) VALUES (?,?,?,?)"
		For cntr = 0 To IngredientList.Size-1
			m.Initialize
			m = IngredientList.Get(cntr)
			sql1.ExecNonQuery2(QueryString,Array As String(LastpkID,m.Get("Qty"),m.Get("UOM"),m.Get("Ingredient")))
		Next
		'-------------------------	
		'write to instructions table
		QueryString = "INSERT INTO instructions (RecipeID,InstructionsData) VALUES (?,?)"
		sql1.ExecNonQuery2(QueryString,Array As String(LastpkID,edtInstructions.Text))
		'-------------------------	
		'write to recipecategories table
		'Log("About to write Category List")
		LogRecipeCategoryList
		QueryString = "INSERT INTO recipecategories (RecipeID,MainCatKey) VALUES (?,?)"
		For cntr = 0 To RecipeCategoryList.Size-1
			m.Initialize
			m = RecipeCategoryList.Get(cntr)
			sql1.ExecNonQuery2(QueryString,Array As String(LastpkID,m.Get("pkID")))
		Next
		'-------------------------	
		Msgbox("Record saved","Save Record")
	End If
End Sub

Sub CheckRecipeData
	Dim isok As Boolean
	Dim resp As Int
	Dim msg As String
	'-------------------------	
	isok = True
	If edtTitle.Text = "" Then
		isok = False
	End If
	If edtSource.Text = "" Then
		isok = False
	End If
	If edtServings.Text = "" Then
		isok = False
	End If
	msg = "One or more Main Recipe fields are blank.  Are you sure you want to continue to save?"
	If isok = False Then
		resp = Msgbox2(msg,"Missing Information","Yes","","NO",Null)
		If resp = DialogResponse.POSITIVE Then
			Return True
		Else
			Return False
		End If
	Else
		Return True
	End If
End Sub

Sub CheckIngredientData
	Dim isok As Boolean
	Dim resp As Int
	Dim msg As String
	'-------------------------
	If IngredientList.Size > 0 Then
		isok = True
	Else
		isok = False
	End If
	If isok = False Then
		resp = Msgbox2(msg,"Missing Ingredient Information","Yes","","NO",Null)
		If resp = DialogResponse.POSITIVE Then
			Return True
		Else
			Return False
		End If
	Else
		Return True
	End If
End Sub

Sub CheckInstructionData
	If edtInstructions.Text = "" Then
	
	End If
End Sub

Sub LogIngredientlist
	Dim cntr As Int
	'-------------------------
	For cntr = 0 To IngredientList.Size-1
		Log(IngredientList.Get(cntr))
	Next
End Sub

Sub btnCancel_Click
	
End Sub

Sub lvIngredientList_ItemClick (Position As Int, Value As Object)
	Dim resp As Int
	Dim tlist As List
	Dim m As Map
	Dim cntr As Int
	'-------------------------
	tlist.Initialize
	tlist.AddAll(Array As String("Cancel","Edit","Delete"))
	
	resp = InputList(tlist,"Edit or Delete",-1)
	If resp = 1 Then
		resp = InputList(OptionList,"Please Select",0)
		If resp = 0 Then 'Edit
			LoadIngredientsForEdit(Position)
		End If	
	Else If resp = 2 Then
		For cntr = 0 To IngredientList.Size-1
			m = IngredientList.Get(cntr)
			If Main.DebugMode = True Then 
				Log(m.Get("Qty") & " " & m.Get("UOM") & " " & m.Get("Ingredient"))
			End If
		Next
		If Main.DebugMode = True Then
			Log("About to remove item at position " & Position)
		End If
		IngredientList.RemoveAt(Position)
		lvIngredientList.RemoveAt(Position)
		For cntr = 0 To IngredientList.Size-1
			m = IngredientList.Get(cntr)
			If Main.DebugMode = True Then 
				Log(m.Get("Qty") & " " & m.Get("UOM") & " " & m.Get("Ingredient"))
			End If
		Next		
		IngredientsChanged = True
	End If
End Sub

Sub edtTitle_EnterPressed
	edtSource.RequestFocus
End Sub

Sub edtSource_EnterPressed
	edtServings.RequestFocus
End Sub

Sub edtServings_EnterPressed
	edtQty.RequestFocus
	IME1.HideKeyboard
End Sub

Sub edtInstructions_EnterPressed
	
End Sub

Sub edtInstructions_TextChanged (Old As String, New As String)
	InstructionsChanged = True
End Sub

Sub lblUnits_Click
	Dim resp As Int
	'-------------------------	
	resp = InputList(UOMList,"Please select a Unit Of Measure",-1)
	If resp > -1 Then
		lblUnits.Text = UOMList.Get(resp)
	End If
End Sub

Sub LoadIngredientsForEdit(which As Int)
	Dim m As Map
	'-------------------------
	m.Initialize
	m = IngredientList.Get(which)
	edtQty.Text = m.Get("Qty")
	edtIngredients.Text = m.Get("Ingredient")
	lblUnits.Text = m.Get("UOM")
	IngredientList.RemoveAt(which)
	lvIngredientList.RemoveAt(which)
End Sub

Sub GetLastKey(DatabaseTable As String) As Int
	Dim QueryString As String
	Dim Cursor1 As Cursor
	Dim LastID As Int
	'-------------------------	
	QueryString = "SELECT last_insert_rowid() as id FROM " & DatabaseTable
	Cursor1 = sql1.ExecQuery(QueryString)
	If Cursor1.RowCount > 0 Then
		Cursor1.Position = 0
		LastID = Cursor1.GetInt("id")
		'Log("LastID = " & LastID)
	Else
		'Log("Error getting last pkID inserted")
	End If
	Return LastID
End Sub

Sub lvCategories_ItemClick (Position As Int, Value As Object)
	Dim m As Map
	Dim pkid As Int
	Dim text As String
	Dim cntr As Int
	'-------------------------	
	'get the map that corresponds with the item clicked
	m.Initialize
	m = CategoryList.Get(Position)
	pkid = m.Get("pkID")
	text = m.Get("text")
	RecipeCategoryList.Add(m)
	If lblCategories.text = "" Then
		lblCategories.text = text
	Else
		lblCategories.text = lblCategories.text & ", " & text
	End If
	CategoriesChanged = True
	LogRecipeCategoryList
End Sub

Sub lblCategories_Click
	Dim resp As Int
	Dim itms As List
	Dim cntr As Int
	Dim tmplist As List
	Dim m As Map
	'-------------------------	
	'initialize the lists
	itms.Initialize
	tmplist.Initialize
	'add "Cancel" and categories to the list
	tmplist.Add("Cancel")
	For cntr = 0 To RecipeCategoryList.Size-1
		m.Initialize
		m = RecipeCategoryList.Get(cntr)
		tmplist.Add(m.Get("text"))
	Next
	itms.AddAll(tmplist)
	resp = InputList(itms,"Delete which category?",0)
	If resp > 0 Then
		RecipeCategoryList.RemoveAt(resp-1)
		lblCategories.Text = ""
		For cntr = 0 To RecipeCategoryList.Size - 1
			m.Initialize
			m = RecipeCategoryList.Get(cntr)
			If cntr = 0 Then
				lblCategories.Text = m.Get("text")
			Else
				lblCategories.Text = lblCategories.Text & ", " & m.Get("text")
			End If
		Next
		CategoriesChanged = True
	End If
End Sub

Sub LogRecipeCategoryList
	Dim cntr As Int
	Dim m As Map
	'-------------------------	
	For cntr = 0 To RecipeCategoryList.Size-1
		m.Initialize
		m = RecipeCategoryList.Get(cntr)
		Log("Counter - " & cntr & " pkid - " & m.Get("pkID") & " Text - " & m.Get("text"))
	Next
End Sub

Sub edtTitle_TextChanged (Old As String, New As String)
	RecipeChanged = True
End Sub

Sub edtSource_TextChanged (Old As String, New As String)
	RecipeChanged = True
End Sub

Sub edtServings_TextChanged (Old As String, New As String)
	RecipeChanged = True
End Sub

Sub CheckSingleQuote(str As String)
	str = str.Replace("'","''")
	Return str
End Sub

Sub btnHideKeyboard_Click
	IME1.HideKeyboard
End Sub


'-------------------------